effect give @s resistance infinite 5 true
effect give @s invisibility infinite 0 true

# Rotate model
execute on passengers store result entity @s Rotation[0] float 1 run execute on vehicle run data get entity @s Rotation[0]
# Glowing
execute if predicate snc:titan/has_glowing on passengers run data merge entity @s {Glowing:1b}
execute unless predicate snc:titan/has_glowing on passengers run data merge entity @s {Glowing:0b}
# Is moving?
execute store result score @s movx run data get entity @s Motion[0] 10000
execute store result score @s movz run data get entity @s Motion[2] 10000
execute if score @s movx matches ..-1 run scoreboard players operation @s movx *= #-1 config
execute if score @s movz matches ..-1 run scoreboard players operation @s movz *= #-1 config
scoreboard players operation @s movx *= @s movz 

execute if score @s movx matches 1.. on passengers run tag @s add walk

scoreboard players reset @s movx
scoreboard players reset @s movz

#  Clipped
execute unless block ~ ~1 ~ air run tp ~ ~1 ~
# execute if score @s movx matches 0 on passengers run tag @s remove walk

## Despawn
function snc:titans/ai/despawn

## Attack
execute rotated ~ 0 positioned ^ ^ ^2 on passengers run function snc:titans/ai/attack

# Dont enter in houses
execute unless block ^ ^2.5 ^.5 air if block ^ ^2.5 ^-.5 air run tp @s ^ ^ ^-1.5
execute unless block ^ ^3.5 ^.5 air if block ^ ^3.5 ^-.5 air run tp @s ^ ^ ^-1.5

# Running in water (This is concerning)
execute if block ^ ^1 ^.5 water run function snc:titans/water

# Dont glitch in terrain
# execute unless block ~ ~ ~ #snc:filter_pure run tp @s ~ ~1 ~

# to record
# execute if block ~ ~ ~ sand run tp @s ~ ~1 ~
# execute if block ~ ~ ~ grass_block run tp @s ~ ~1 ~
# execute if block ~ ~ ~ stone run tp @s ~ ~1 ~

# Kill if has no passengers
execute unless data entity @s Passengers run function snc:controller/kill_mob

#speed
# Sunrise
execute if score time clock matches 23001..23999 run effect give @s[tag=!mob8] slowness 2 0 true
execute if score time clock matches 0..6400 run effect give @s[tag=!mob8] slowness 2 0 true
# Noon
execute if score time clock matches 6500..12000 run effect clear @s slowness
# Sunset
execute if score time clock matches 12050..14000 run effect give @s[tag=!mob8] slowness 2 0 true
# Night
execute if score time clock matches 14050..23000 run effect give @s[tag=!mob8] slowness 2 2 true

scoreboard players add titan_count spawn 1